import serial
import sys

def main():
	#port is set to the port by the user, this is an example value
	port = "/dev/ttyUSB0"
	#baudrate is set to the baud rate by the user, this is an example value
	baudrate = 921600
	
	#Get the port and baudrate
	if len(sys.argv) == 3:
		port = sys.argv[1]
		baudrate = sys.argv[2]
	else:
		print('Improper usage, expecting python SerialEchoConsole.py <port> <baudrate>')
		print('Note: this file accepts both Windows and Linux ports, for example COM3 as well as /dev/ttyUSB0 would both be accepted')
		print('Note: if using this serial echo colsole for the base MicroCART files the baud rate should be 921600')
		return 1
		
	print('Starting...')
	
	with serial.Serial(port=port, baudrate=baudrate, bytesize=serial.EIGHTBITS, parity=serial.PARITY_NONE, stopbits=serial.STOPBITS_ONE, timeout=None) as ser:
		#ser.open()
		counter = 0
		while ser.is_open:
			
			if ser.in_waiting > 0:
				rec = ser.read(ser.in_waiting)
				print(":".join("{:02x}".format(c) for c in rec))
				ser.write(bytes(rec))
				print('.', end='')
				sys.stdout.flush()
				counter += 1
				if counter > 50:
					counter = 0
					print()
				
			#if not sys.stdin.isatty():
			#	for line in sys.stdin:
			#		print('Will attempt to write:')
			#		print(line.strip())
	
	print('Exiting...')
	
if __name__ == '__main__':
	main()